"""
@generated by mypy-protobuf.  Do not edit manually!
isort:skip_file
"""

import builtins
import collections.abc
import google.protobuf.descriptor
import google.protobuf.internal.containers
import google.protobuf.internal.enum_type_wrapper
import google.protobuf.message
import sys
import typing
import yandex.cloud.priv.datasphere.v2.nodedeployer.runtime_options_pb2

if sys.version_info >= (3, 10):
    import typing as typing_extensions
else:
    import typing_extensions

DESCRIPTOR: google.protobuf.descriptor.FileDescriptor

@typing.final
class TritonApp(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    MODELS_FIELD_NUMBER: builtins.int
    RUNTIME_OPTIONS_FIELD_NUMBER: builtins.int
    @property
    def models(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___TritonModel]:
        """
        Optional parameter for some models, see docs
        https://docs.nvidia.com/deeplearning/triton-inference-server/user-guide/docs/user_guide/model_configuration.html#minimal-model-configuration
        """

    @property
    def runtime_options(self) -> yandex.cloud.priv.datasphere.v2.nodedeployer.runtime_options_pb2.RuntimeOptions: ...
    def __init__(
        self,
        *,
        models: collections.abc.Iterable[global___TritonModel] | None = ...,
        runtime_options: yandex.cloud.priv.datasphere.v2.nodedeployer.runtime_options_pb2.RuntimeOptions | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["runtime_options", b"runtime_options"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["models", b"models", "runtime_options", b"runtime_options"]) -> None: ...

global___TritonApp = TritonApp

@typing.final
class TritonModel(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    ID_FIELD_NUMBER: builtins.int
    TRITON_MODEL_CONFIG_FIELD_NUMBER: builtins.int
    id: builtins.str
    @property
    def triton_model_config(self) -> global___ModelConfig: ...
    def __init__(
        self,
        *,
        id: builtins.str = ...,
        triton_model_config: global___ModelConfig | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["triton_model_config", b"triton_model_config"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["id", b"id", "triton_model_config", b"triton_model_config"]) -> None: ...

global___TritonModel = TritonModel

@typing.final
class ModelConfig(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    class _DataType:
        ValueType = typing.NewType("ValueType", builtins.int)
        V: typing_extensions.TypeAlias = ValueType

    class _DataTypeEnumTypeWrapper(google.protobuf.internal.enum_type_wrapper._EnumTypeWrapper[ModelConfig._DataType.ValueType], builtins.type):
        DESCRIPTOR: google.protobuf.descriptor.EnumDescriptor
        TYPE_BOOL: ModelConfig._DataType.ValueType  # 0
        TYPE_UINT8: ModelConfig._DataType.ValueType  # 1
        TYPE_UINT16: ModelConfig._DataType.ValueType  # 2
        TYPE_UINT32: ModelConfig._DataType.ValueType  # 3
        TYPE_UINT64: ModelConfig._DataType.ValueType  # 4
        TYPE_INT8: ModelConfig._DataType.ValueType  # 5
        TYPE_INT16: ModelConfig._DataType.ValueType  # 6
        TYPE_INT32: ModelConfig._DataType.ValueType  # 7
        TYPE_INT64: ModelConfig._DataType.ValueType  # 8
        TYPE_FP16: ModelConfig._DataType.ValueType  # 9
        TYPE_FP32: ModelConfig._DataType.ValueType  # 10
        TYPE_FP64: ModelConfig._DataType.ValueType  # 11
        TYPE_STRING: ModelConfig._DataType.ValueType  # 12
        TYPE_BF16: ModelConfig._DataType.ValueType  # 13

    class DataType(_DataType, metaclass=_DataTypeEnumTypeWrapper): ...
    TYPE_BOOL: ModelConfig.DataType.ValueType  # 0
    TYPE_UINT8: ModelConfig.DataType.ValueType  # 1
    TYPE_UINT16: ModelConfig.DataType.ValueType  # 2
    TYPE_UINT32: ModelConfig.DataType.ValueType  # 3
    TYPE_UINT64: ModelConfig.DataType.ValueType  # 4
    TYPE_INT8: ModelConfig.DataType.ValueType  # 5
    TYPE_INT16: ModelConfig.DataType.ValueType  # 6
    TYPE_INT32: ModelConfig.DataType.ValueType  # 7
    TYPE_INT64: ModelConfig.DataType.ValueType  # 8
    TYPE_FP16: ModelConfig.DataType.ValueType  # 9
    TYPE_FP32: ModelConfig.DataType.ValueType  # 10
    TYPE_FP64: ModelConfig.DataType.ValueType  # 11
    TYPE_STRING: ModelConfig.DataType.ValueType  # 12
    TYPE_BF16: ModelConfig.DataType.ValueType  # 13

    @typing.final
    class ModelInput(google.protobuf.message.Message):
        DESCRIPTOR: google.protobuf.descriptor.Descriptor

        NAME_FIELD_NUMBER: builtins.int
        DATA_TYPE_FIELD_NUMBER: builtins.int
        DIMS_FIELD_NUMBER: builtins.int
        name: builtins.str
        data_type: global___ModelConfig.DataType.ValueType
        @property
        def dims(self) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[builtins.int]: ...
        def __init__(
            self,
            *,
            name: builtins.str = ...,
            data_type: global___ModelConfig.DataType.ValueType = ...,
            dims: collections.abc.Iterable[builtins.int] | None = ...,
        ) -> None: ...
        def ClearField(self, field_name: typing.Literal["data_type", b"data_type", "dims", b"dims", "name", b"name"]) -> None: ...

    @typing.final
    class ModelOutput(google.protobuf.message.Message):
        DESCRIPTOR: google.protobuf.descriptor.Descriptor

        NAME_FIELD_NUMBER: builtins.int
        DATA_TYPE_FIELD_NUMBER: builtins.int
        DIMS_FIELD_NUMBER: builtins.int
        name: builtins.str
        data_type: global___ModelConfig.DataType.ValueType
        @property
        def dims(self) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[builtins.int]: ...
        def __init__(
            self,
            *,
            name: builtins.str = ...,
            data_type: global___ModelConfig.DataType.ValueType = ...,
            dims: collections.abc.Iterable[builtins.int] | None = ...,
        ) -> None: ...
        def ClearField(self, field_name: typing.Literal["data_type", b"data_type", "dims", b"dims", "name", b"name"]) -> None: ...

    INPUT_FIELD_NUMBER: builtins.int
    OUTPUT_FIELD_NUMBER: builtins.int
    @property
    def input(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___ModelConfig.ModelInput]: ...
    @property
    def output(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___ModelConfig.ModelOutput]: ...
    def __init__(
        self,
        *,
        input: collections.abc.Iterable[global___ModelConfig.ModelInput] | None = ...,
        output: collections.abc.Iterable[global___ModelConfig.ModelOutput] | None = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["input", b"input", "output", b"output"]) -> None: ...

global___ModelConfig = ModelConfig
