"""
@generated by mypy-protobuf.  Do not edit manually!
isort:skip_file
"""

import builtins
import collections.abc
import google.protobuf.descriptor
import google.protobuf.duration_pb2
import google.protobuf.field_mask_pb2
import google.protobuf.internal.containers
import google.protobuf.message
import google.protobuf.timestamp_pb2
import typing
import yandex.cloud.priv.iam.v1.mfa.hardware.totp_profile_pb2
import yandex.cloud.priv.iam.v1.mfa.totp_profile_pb2
import yandex.cloud.priv.operation.operation_pb2

DESCRIPTOR: google.protobuf.descriptor.FileDescriptor

@typing.final
class CreateTotpProfileRequest(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    @typing.final
    class LabelsEntry(google.protobuf.message.Message):
        DESCRIPTOR: google.protobuf.descriptor.Descriptor

        KEY_FIELD_NUMBER: builtins.int
        VALUE_FIELD_NUMBER: builtins.int
        key: builtins.str
        value: builtins.str
        def __init__(
            self,
            *,
            key: builtins.str = ...,
            value: builtins.str = ...,
        ) -> None: ...
        def ClearField(self, field_name: typing.Literal["key", b"key", "value", b"value"]) -> None: ...

    ORGANIZATION_ID_FIELD_NUMBER: builtins.int
    SUBJECT_ID_FIELD_NUMBER: builtins.int
    DESCRIPTION_FIELD_NUMBER: builtins.int
    LABELS_FIELD_NUMBER: builtins.int
    ALGORITHM_FIELD_NUMBER: builtins.int
    DIGITS_FIELD_NUMBER: builtins.int
    TIME_STEP_FIELD_NUMBER: builtins.int
    SECRET_FIELD_NUMBER: builtins.int
    SERIAL_NO_FIELD_NUMBER: builtins.int
    MANUFACTURER_FIELD_NUMBER: builtins.int
    MODEL_FIELD_NUMBER: builtins.int
    START_TIME_FIELD_NUMBER: builtins.int
    TIME_DRIFT_FIELD_NUMBER: builtins.int
    organization_id: builtins.str
    """The organization in which the hardware token is registered"""
    subject_id: builtins.str
    """An optional subject_id to auto-assign"""
    description: builtins.str
    """Optional description"""
    algorithm: yandex.cloud.priv.iam.v1.mfa.totp_profile_pb2.HashAlgorithm.ValueType
    """Algorithm used to calculate the hash (SHA1, SHA256 or SHA512). Default is SHA1."""
    digits: builtins.int
    """Length of the TOTP code (6, 7 or 8). Default is 6."""
    secret: builtins.str
    """secret encoded in HEX"""
    serial_no: builtins.str
    """Serial number hardware token"""
    manufacturer: builtins.str
    """Manufacturer hardware token"""
    model: builtins.str
    """Model hardware token"""
    @property
    def labels(self) -> google.protobuf.internal.containers.ScalarMap[builtins.str, builtins.str]:
        """Optional labels"""

    @property
    def time_step(self) -> google.protobuf.duration_pb2.Duration:
        """The period that a TOTP code will be valid for."""

    @property
    def start_time(self) -> google.protobuf.timestamp_pb2.Timestamp:
        """Start time for the hardware token. Default is Unix Epoch."""

    @property
    def time_drift(self) -> google.protobuf.duration_pb2.Duration:
        """Token time lags"""

    def __init__(
        self,
        *,
        organization_id: builtins.str = ...,
        subject_id: builtins.str = ...,
        description: builtins.str = ...,
        labels: collections.abc.Mapping[builtins.str, builtins.str] | None = ...,
        algorithm: yandex.cloud.priv.iam.v1.mfa.totp_profile_pb2.HashAlgorithm.ValueType = ...,
        digits: builtins.int = ...,
        time_step: google.protobuf.duration_pb2.Duration | None = ...,
        secret: builtins.str = ...,
        serial_no: builtins.str = ...,
        manufacturer: builtins.str = ...,
        model: builtins.str = ...,
        start_time: google.protobuf.timestamp_pb2.Timestamp | None = ...,
        time_drift: google.protobuf.duration_pb2.Duration | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["start_time", b"start_time", "time_drift", b"time_drift", "time_step", b"time_step"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["algorithm", b"algorithm", "description", b"description", "digits", b"digits", "labels", b"labels", "manufacturer", b"manufacturer", "model", b"model", "organization_id", b"organization_id", "secret", b"secret", "serial_no", b"serial_no", "start_time", b"start_time", "subject_id", b"subject_id", "time_drift", b"time_drift", "time_step", b"time_step"]) -> None: ...

global___CreateTotpProfileRequest = CreateTotpProfileRequest

@typing.final
class CreateTotpProfileMetadata(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    TOTP_PROFILE_ID_FIELD_NUMBER: builtins.int
    totp_profile_id: builtins.str
    def __init__(
        self,
        *,
        totp_profile_id: builtins.str = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["totp_profile_id", b"totp_profile_id"]) -> None: ...

global___CreateTotpProfileMetadata = CreateTotpProfileMetadata

@typing.final
class ImportTotpProfilesRequest(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    @typing.final
    class LabelsEntry(google.protobuf.message.Message):
        DESCRIPTOR: google.protobuf.descriptor.Descriptor

        KEY_FIELD_NUMBER: builtins.int
        VALUE_FIELD_NUMBER: builtins.int
        key: builtins.str
        value: builtins.str
        def __init__(
            self,
            *,
            key: builtins.str = ...,
            value: builtins.str = ...,
        ) -> None: ...
        def ClearField(self, field_name: typing.Literal["key", b"key", "value", b"value"]) -> None: ...

    DATA_FIELD_NUMBER: builtins.int
    ORGANIZATION_ID_FIELD_NUMBER: builtins.int
    ALGORITHM_FIELD_NUMBER: builtins.int
    DIGITS_FIELD_NUMBER: builtins.int
    TIME_STEP_FIELD_NUMBER: builtins.int
    DESCRIPTION_FIELD_NUMBER: builtins.int
    LABELS_FIELD_NUMBER: builtins.int
    MANUFACTURER_FIELD_NUMBER: builtins.int
    MODEL_FIELD_NUMBER: builtins.int
    data: builtins.str
    """Data from file csv, secret encoded in HEX"""
    organization_id: builtins.str
    algorithm: yandex.cloud.priv.iam.v1.mfa.totp_profile_pb2.HashAlgorithm.ValueType
    digits: builtins.int
    description: builtins.str
    manufacturer: builtins.str
    model: builtins.str
    @property
    def time_step(self) -> google.protobuf.duration_pb2.Duration: ...
    @property
    def labels(self) -> google.protobuf.internal.containers.ScalarMap[builtins.str, builtins.str]: ...
    def __init__(
        self,
        *,
        data: builtins.str = ...,
        organization_id: builtins.str = ...,
        algorithm: yandex.cloud.priv.iam.v1.mfa.totp_profile_pb2.HashAlgorithm.ValueType = ...,
        digits: builtins.int = ...,
        time_step: google.protobuf.duration_pb2.Duration | None = ...,
        description: builtins.str = ...,
        labels: collections.abc.Mapping[builtins.str, builtins.str] | None = ...,
        manufacturer: builtins.str = ...,
        model: builtins.str = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["time_step", b"time_step"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["algorithm", b"algorithm", "data", b"data", "description", b"description", "digits", b"digits", "labels", b"labels", "manufacturer", b"manufacturer", "model", b"model", "organization_id", b"organization_id", "time_step", b"time_step"]) -> None: ...

global___ImportTotpProfilesRequest = ImportTotpProfilesRequest

@typing.final
class ImportTotpProfilesMetadata(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    def __init__(
        self,
    ) -> None: ...

global___ImportTotpProfilesMetadata = ImportTotpProfilesMetadata

@typing.final
class ImportTotpProfilesResponse(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    TOTP_PROFILES_FIELD_NUMBER: builtins.int
    @property
    def totp_profiles(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[yandex.cloud.priv.iam.v1.mfa.hardware.totp_profile_pb2.TotpProfile]: ...
    def __init__(
        self,
        *,
        totp_profiles: collections.abc.Iterable[yandex.cloud.priv.iam.v1.mfa.hardware.totp_profile_pb2.TotpProfile] | None = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["totp_profiles", b"totp_profiles"]) -> None: ...

global___ImportTotpProfilesResponse = ImportTotpProfilesResponse

@typing.final
class GetTotpProfileRequest(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    TOTP_PROFILE_ID_FIELD_NUMBER: builtins.int
    totp_profile_id: builtins.str
    def __init__(
        self,
        *,
        totp_profile_id: builtins.str = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["totp_profile_id", b"totp_profile_id"]) -> None: ...

global___GetTotpProfileRequest = GetTotpProfileRequest

@typing.final
class ListTotpProfilesRequest(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    ORGANIZATION_ID_FIELD_NUMBER: builtins.int
    FILTER_FIELD_NUMBER: builtins.int
    PAGE_SIZE_FIELD_NUMBER: builtins.int
    PAGE_TOKEN_FIELD_NUMBER: builtins.int
    organization_id: builtins.str
    filter: builtins.str
    page_size: builtins.int
    page_token: builtins.str
    def __init__(
        self,
        *,
        organization_id: builtins.str = ...,
        filter: builtins.str = ...,
        page_size: builtins.int = ...,
        page_token: builtins.str = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["filter", b"filter", "organization_id", b"organization_id", "page_size", b"page_size", "page_token", b"page_token"]) -> None: ...

global___ListTotpProfilesRequest = ListTotpProfilesRequest

@typing.final
class ListTotpProfilesResponse(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    TOTP_PROFILES_FIELD_NUMBER: builtins.int
    NEXT_PAGE_TOKEN_FIELD_NUMBER: builtins.int
    next_page_token: builtins.str
    @property
    def totp_profiles(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[yandex.cloud.priv.iam.v1.mfa.hardware.totp_profile_pb2.TotpProfile]: ...
    def __init__(
        self,
        *,
        totp_profiles: collections.abc.Iterable[yandex.cloud.priv.iam.v1.mfa.hardware.totp_profile_pb2.TotpProfile] | None = ...,
        next_page_token: builtins.str = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["next_page_token", b"next_page_token", "totp_profiles", b"totp_profiles"]) -> None: ...

global___ListTotpProfilesResponse = ListTotpProfilesResponse

@typing.final
class UpdateTotpProfileRequest(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    @typing.final
    class LabelsEntry(google.protobuf.message.Message):
        DESCRIPTOR: google.protobuf.descriptor.Descriptor

        KEY_FIELD_NUMBER: builtins.int
        VALUE_FIELD_NUMBER: builtins.int
        key: builtins.str
        value: builtins.str
        def __init__(
            self,
            *,
            key: builtins.str = ...,
            value: builtins.str = ...,
        ) -> None: ...
        def ClearField(self, field_name: typing.Literal["key", b"key", "value", b"value"]) -> None: ...

    TOTP_PROFILE_ID_FIELD_NUMBER: builtins.int
    UPDATE_MASK_FIELD_NUMBER: builtins.int
    DESCRIPTION_FIELD_NUMBER: builtins.int
    LABELS_FIELD_NUMBER: builtins.int
    totp_profile_id: builtins.str
    description: builtins.str
    @property
    def update_mask(self) -> google.protobuf.field_mask_pb2.FieldMask:
        """Mask specifying which totp profile fields will be updated."""

    @property
    def labels(self) -> google.protobuf.internal.containers.ScalarMap[builtins.str, builtins.str]: ...
    def __init__(
        self,
        *,
        totp_profile_id: builtins.str = ...,
        update_mask: google.protobuf.field_mask_pb2.FieldMask | None = ...,
        description: builtins.str = ...,
        labels: collections.abc.Mapping[builtins.str, builtins.str] | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["update_mask", b"update_mask"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["description", b"description", "labels", b"labels", "totp_profile_id", b"totp_profile_id", "update_mask", b"update_mask"]) -> None: ...

global___UpdateTotpProfileRequest = UpdateTotpProfileRequest

@typing.final
class UpdateTotpProfileMetadata(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    TOTP_PROFILE_ID_FIELD_NUMBER: builtins.int
    totp_profile_id: builtins.str
    def __init__(
        self,
        *,
        totp_profile_id: builtins.str = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["totp_profile_id", b"totp_profile_id"]) -> None: ...

global___UpdateTotpProfileMetadata = UpdateTotpProfileMetadata

@typing.final
class DeleteTotpProfileRequest(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    TOTP_PROFILE_ID_FIELD_NUMBER: builtins.int
    totp_profile_id: builtins.str
    def __init__(
        self,
        *,
        totp_profile_id: builtins.str = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["totp_profile_id", b"totp_profile_id"]) -> None: ...

global___DeleteTotpProfileRequest = DeleteTotpProfileRequest

@typing.final
class DeleteTotpProfileMetadata(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    TOTP_PROFILE_ID_FIELD_NUMBER: builtins.int
    totp_profile_id: builtins.str
    def __init__(
        self,
        *,
        totp_profile_id: builtins.str = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["totp_profile_id", b"totp_profile_id"]) -> None: ...

global___DeleteTotpProfileMetadata = DeleteTotpProfileMetadata

@typing.final
class ListTotpProfileOperationsRequest(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    TOTP_PROFILE_ID_FIELD_NUMBER: builtins.int
    ORGANIZATION_ID_FIELD_NUMBER: builtins.int
    PAGE_SIZE_FIELD_NUMBER: builtins.int
    PAGE_TOKEN_FIELD_NUMBER: builtins.int
    totp_profile_id: builtins.str
    organization_id: builtins.str
    page_size: builtins.int
    page_token: builtins.str
    def __init__(
        self,
        *,
        totp_profile_id: builtins.str = ...,
        organization_id: builtins.str = ...,
        page_size: builtins.int = ...,
        page_token: builtins.str = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["from", b"from", "organization_id", b"organization_id", "totp_profile_id", b"totp_profile_id"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["from", b"from", "organization_id", b"organization_id", "page_size", b"page_size", "page_token", b"page_token", "totp_profile_id", b"totp_profile_id"]) -> None: ...
    def WhichOneof(self, oneof_group: typing.Literal["from", b"from"]) -> typing.Literal["totp_profile_id", "organization_id"] | None: ...

global___ListTotpProfileOperationsRequest = ListTotpProfileOperationsRequest

@typing.final
class ListTotpProfileOperationsResponse(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    OPERATIONS_FIELD_NUMBER: builtins.int
    NEXT_PAGE_TOKEN_FIELD_NUMBER: builtins.int
    next_page_token: builtins.str
    @property
    def operations(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[yandex.cloud.priv.operation.operation_pb2.Operation]: ...
    def __init__(
        self,
        *,
        operations: collections.abc.Iterable[yandex.cloud.priv.operation.operation_pb2.Operation] | None = ...,
        next_page_token: builtins.str = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["next_page_token", b"next_page_token", "operations", b"operations"]) -> None: ...

global___ListTotpProfileOperationsResponse = ListTotpProfileOperationsResponse

@typing.final
class AssignTotpProfileRequest(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    TOTP_PROFILE_ID_FIELD_NUMBER: builtins.int
    SUBJECT_ID_FIELD_NUMBER: builtins.int
    totp_profile_id: builtins.str
    subject_id: builtins.str
    def __init__(
        self,
        *,
        totp_profile_id: builtins.str = ...,
        subject_id: builtins.str = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["subject_id", b"subject_id", "totp_profile_id", b"totp_profile_id"]) -> None: ...

global___AssignTotpProfileRequest = AssignTotpProfileRequest

@typing.final
class AssignTotpProfileMetadata(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    TOTP_PROFILE_ID_FIELD_NUMBER: builtins.int
    totp_profile_id: builtins.str
    def __init__(
        self,
        *,
        totp_profile_id: builtins.str = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["totp_profile_id", b"totp_profile_id"]) -> None: ...

global___AssignTotpProfileMetadata = AssignTotpProfileMetadata

@typing.final
class UnassignTotpProfileRequest(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    TOTP_PROFILE_ID_FIELD_NUMBER: builtins.int
    totp_profile_id: builtins.str
    def __init__(
        self,
        *,
        totp_profile_id: builtins.str = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["totp_profile_id", b"totp_profile_id"]) -> None: ...

global___UnassignTotpProfileRequest = UnassignTotpProfileRequest

@typing.final
class UnassignTotpProfileMetadata(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    TOTP_PROFILE_ID_FIELD_NUMBER: builtins.int
    totp_profile_id: builtins.str
    def __init__(
        self,
        *,
        totp_profile_id: builtins.str = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["totp_profile_id", b"totp_profile_id"]) -> None: ...

global___UnassignTotpProfileMetadata = UnassignTotpProfileMetadata

@typing.final
class SyncTimeDriftRequest(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    TOTP_PROFILE_ID_FIELD_NUMBER: builtins.int
    CODE_FIELD_NUMBER: builtins.int
    WINDOW_SIZE_FIELD_NUMBER: builtins.int
    totp_profile_id: builtins.str
    window_size: builtins.int
    """Maximum number of steps time_step by which the time of the server and the token can differ. Default value is 25"""
    @property
    def code(self) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[builtins.int]: ...
    def __init__(
        self,
        *,
        totp_profile_id: builtins.str = ...,
        code: collections.abc.Iterable[builtins.int] | None = ...,
        window_size: builtins.int = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["code", b"code", "totp_profile_id", b"totp_profile_id", "window_size", b"window_size"]) -> None: ...

global___SyncTimeDriftRequest = SyncTimeDriftRequest

@typing.final
class SyncTimeDriftMetadata(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    TOTP_PROFILE_ID_FIELD_NUMBER: builtins.int
    totp_profile_id: builtins.str
    def __init__(
        self,
        *,
        totp_profile_id: builtins.str = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["totp_profile_id", b"totp_profile_id"]) -> None: ...

global___SyncTimeDriftMetadata = SyncTimeDriftMetadata

@typing.final
class VerifyTotpRequest(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    CODE_FIELD_NUMBER: builtins.int
    TOTP_PROFILE_ID_FIELD_NUMBER: builtins.int
    code: builtins.int
    totp_profile_id: builtins.str
    def __init__(
        self,
        *,
        code: builtins.int = ...,
        totp_profile_id: builtins.str = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["code", b"code", "totp_profile_id", b"totp_profile_id"]) -> None: ...

global___VerifyTotpRequest = VerifyTotpRequest

@typing.final
class VerifyTotpResponse(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    RESULT_FIELD_NUMBER: builtins.int
    RETRY_AT_FIELD_NUMBER: builtins.int
    result: yandex.cloud.priv.iam.v1.mfa.totp_profile_pb2.VerificationResult.ValueType
    @property
    def retry_at(self) -> google.protobuf.timestamp_pb2.Timestamp: ...
    def __init__(
        self,
        *,
        result: yandex.cloud.priv.iam.v1.mfa.totp_profile_pb2.VerificationResult.ValueType = ...,
        retry_at: google.protobuf.timestamp_pb2.Timestamp | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["retry_at", b"retry_at"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["result", b"result", "retry_at", b"retry_at"]) -> None: ...

global___VerifyTotpResponse = VerifyTotpResponse
