"""
@generated by mypy-protobuf.  Do not edit manually!
isort:skip_file
"""

import abc
import collections.abc
import grpc
import grpc.aio
import typing
import yandex.cloud.priv.iam.v1.mfa.hardware.totp_profile_pb2
import yandex.cloud.priv.iam.v1.mfa.hardware.totp_profile_service_pb2
import yandex.cloud.priv.operation.operation_pb2

_T = typing.TypeVar("_T")

class _MaybeAsyncIterator(collections.abc.AsyncIterator[_T], collections.abc.Iterator[_T], metaclass=abc.ABCMeta): ...

class _ServicerContext(grpc.ServicerContext, grpc.aio.ServicerContext):  # type: ignore[misc, type-arg]
    ...

class TotpProfileServiceStub:
    """A set of methods for managing hardware time-based one time passwords (TOTP).
    The user credentials should be passed in the authorization header.
    """

    def __init__(self, channel: typing.Union[grpc.Channel, grpc.aio.Channel]) -> None: ...
    Create: grpc.UnaryUnaryMultiCallable[
        yandex.cloud.priv.iam.v1.mfa.hardware.totp_profile_service_pb2.CreateTotpProfileRequest,
        yandex.cloud.priv.operation.operation_pb2.Operation,
    ]
    """Creates hardware TOTP profile"""

    ImportFromFile: grpc.UnaryUnaryMultiCallable[
        yandex.cloud.priv.iam.v1.mfa.hardware.totp_profile_service_pb2.ImportTotpProfilesRequest,
        yandex.cloud.priv.operation.operation_pb2.Operation,
    ]
    """Bulk creates hardware TOTP profiles using file .csv"""

    Get: grpc.UnaryUnaryMultiCallable[
        yandex.cloud.priv.iam.v1.mfa.hardware.totp_profile_service_pb2.GetTotpProfileRequest,
        yandex.cloud.priv.iam.v1.mfa.hardware.totp_profile_pb2.TotpProfile,
    ]
    """Retrieves hardware TOTP profile by Id"""

    List: grpc.UnaryUnaryMultiCallable[
        yandex.cloud.priv.iam.v1.mfa.hardware.totp_profile_service_pb2.ListTotpProfilesRequest,
        yandex.cloud.priv.iam.v1.mfa.hardware.totp_profile_service_pb2.ListTotpProfilesResponse,
    ]
    """Retrieves the list hardware TOTP profiles by organization_id and filter"""

    Update: grpc.UnaryUnaryMultiCallable[
        yandex.cloud.priv.iam.v1.mfa.hardware.totp_profile_service_pb2.UpdateTotpProfileRequest,
        yandex.cloud.priv.operation.operation_pb2.Operation,
    ]
    """Updates hardware TOTP profile"""

    Delete: grpc.UnaryUnaryMultiCallable[
        yandex.cloud.priv.iam.v1.mfa.hardware.totp_profile_service_pb2.DeleteTotpProfileRequest,
        yandex.cloud.priv.operation.operation_pb2.Operation,
    ]
    """Updates hardware TOTP profile by id"""

    ListOperations: grpc.UnaryUnaryMultiCallable[
        yandex.cloud.priv.iam.v1.mfa.hardware.totp_profile_service_pb2.ListTotpProfileOperationsRequest,
        yandex.cloud.priv.iam.v1.mfa.hardware.totp_profile_service_pb2.ListTotpProfileOperationsResponse,
    ]
    """Retrieves the list of Operations for the specified hardware TOTP profile."""

    Assign: grpc.UnaryUnaryMultiCallable[
        yandex.cloud.priv.iam.v1.mfa.hardware.totp_profile_service_pb2.AssignTotpProfileRequest,
        yandex.cloud.priv.operation.operation_pb2.Operation,
    ]
    """Binds the token to the user for HelpDesk"""

    Unassign: grpc.UnaryUnaryMultiCallable[
        yandex.cloud.priv.iam.v1.mfa.hardware.totp_profile_service_pb2.UnassignTotpProfileRequest,
        yandex.cloud.priv.operation.operation_pb2.Operation,
    ]
    """Unbind the token from the user for HelpDesk"""

    SyncTimeDrift: grpc.UnaryUnaryMultiCallable[
        yandex.cloud.priv.iam.v1.mfa.hardware.totp_profile_service_pb2.SyncTimeDriftRequest,
        yandex.cloud.priv.operation.operation_pb2.Operation,
    ]
    """Synchronizes clocks for hardware tokens. Doesn't activate profile."""

    Verify: grpc.UnaryUnaryMultiCallable[
        yandex.cloud.priv.iam.v1.mfa.hardware.totp_profile_service_pb2.VerifyTotpRequest,
        yandex.cloud.priv.iam.v1.mfa.hardware.totp_profile_service_pb2.VerifyTotpResponse,
    ]
    """Verifies user-supplied TOTP value. See https://tools.ietf.org/html/rfc6238#section-5.2 for the reference."""

class TotpProfileServiceAsyncStub:
    """A set of methods for managing hardware time-based one time passwords (TOTP).
    The user credentials should be passed in the authorization header.
    """

    Create: grpc.aio.UnaryUnaryMultiCallable[
        yandex.cloud.priv.iam.v1.mfa.hardware.totp_profile_service_pb2.CreateTotpProfileRequest,
        yandex.cloud.priv.operation.operation_pb2.Operation,
    ]
    """Creates hardware TOTP profile"""

    ImportFromFile: grpc.aio.UnaryUnaryMultiCallable[
        yandex.cloud.priv.iam.v1.mfa.hardware.totp_profile_service_pb2.ImportTotpProfilesRequest,
        yandex.cloud.priv.operation.operation_pb2.Operation,
    ]
    """Bulk creates hardware TOTP profiles using file .csv"""

    Get: grpc.aio.UnaryUnaryMultiCallable[
        yandex.cloud.priv.iam.v1.mfa.hardware.totp_profile_service_pb2.GetTotpProfileRequest,
        yandex.cloud.priv.iam.v1.mfa.hardware.totp_profile_pb2.TotpProfile,
    ]
    """Retrieves hardware TOTP profile by Id"""

    List: grpc.aio.UnaryUnaryMultiCallable[
        yandex.cloud.priv.iam.v1.mfa.hardware.totp_profile_service_pb2.ListTotpProfilesRequest,
        yandex.cloud.priv.iam.v1.mfa.hardware.totp_profile_service_pb2.ListTotpProfilesResponse,
    ]
    """Retrieves the list hardware TOTP profiles by organization_id and filter"""

    Update: grpc.aio.UnaryUnaryMultiCallable[
        yandex.cloud.priv.iam.v1.mfa.hardware.totp_profile_service_pb2.UpdateTotpProfileRequest,
        yandex.cloud.priv.operation.operation_pb2.Operation,
    ]
    """Updates hardware TOTP profile"""

    Delete: grpc.aio.UnaryUnaryMultiCallable[
        yandex.cloud.priv.iam.v1.mfa.hardware.totp_profile_service_pb2.DeleteTotpProfileRequest,
        yandex.cloud.priv.operation.operation_pb2.Operation,
    ]
    """Updates hardware TOTP profile by id"""

    ListOperations: grpc.aio.UnaryUnaryMultiCallable[
        yandex.cloud.priv.iam.v1.mfa.hardware.totp_profile_service_pb2.ListTotpProfileOperationsRequest,
        yandex.cloud.priv.iam.v1.mfa.hardware.totp_profile_service_pb2.ListTotpProfileOperationsResponse,
    ]
    """Retrieves the list of Operations for the specified hardware TOTP profile."""

    Assign: grpc.aio.UnaryUnaryMultiCallable[
        yandex.cloud.priv.iam.v1.mfa.hardware.totp_profile_service_pb2.AssignTotpProfileRequest,
        yandex.cloud.priv.operation.operation_pb2.Operation,
    ]
    """Binds the token to the user for HelpDesk"""

    Unassign: grpc.aio.UnaryUnaryMultiCallable[
        yandex.cloud.priv.iam.v1.mfa.hardware.totp_profile_service_pb2.UnassignTotpProfileRequest,
        yandex.cloud.priv.operation.operation_pb2.Operation,
    ]
    """Unbind the token from the user for HelpDesk"""

    SyncTimeDrift: grpc.aio.UnaryUnaryMultiCallable[
        yandex.cloud.priv.iam.v1.mfa.hardware.totp_profile_service_pb2.SyncTimeDriftRequest,
        yandex.cloud.priv.operation.operation_pb2.Operation,
    ]
    """Synchronizes clocks for hardware tokens. Doesn't activate profile."""

    Verify: grpc.aio.UnaryUnaryMultiCallable[
        yandex.cloud.priv.iam.v1.mfa.hardware.totp_profile_service_pb2.VerifyTotpRequest,
        yandex.cloud.priv.iam.v1.mfa.hardware.totp_profile_service_pb2.VerifyTotpResponse,
    ]
    """Verifies user-supplied TOTP value. See https://tools.ietf.org/html/rfc6238#section-5.2 for the reference."""

class TotpProfileServiceServicer(metaclass=abc.ABCMeta):
    """A set of methods for managing hardware time-based one time passwords (TOTP).
    The user credentials should be passed in the authorization header.
    """

    @abc.abstractmethod
    def Create(
        self,
        request: yandex.cloud.priv.iam.v1.mfa.hardware.totp_profile_service_pb2.CreateTotpProfileRequest,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.priv.operation.operation_pb2.Operation, collections.abc.Awaitable[yandex.cloud.priv.operation.operation_pb2.Operation]]:
        """Creates hardware TOTP profile"""

    @abc.abstractmethod
    def ImportFromFile(
        self,
        request: yandex.cloud.priv.iam.v1.mfa.hardware.totp_profile_service_pb2.ImportTotpProfilesRequest,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.priv.operation.operation_pb2.Operation, collections.abc.Awaitable[yandex.cloud.priv.operation.operation_pb2.Operation]]:
        """Bulk creates hardware TOTP profiles using file .csv"""

    @abc.abstractmethod
    def Get(
        self,
        request: yandex.cloud.priv.iam.v1.mfa.hardware.totp_profile_service_pb2.GetTotpProfileRequest,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.priv.iam.v1.mfa.hardware.totp_profile_pb2.TotpProfile, collections.abc.Awaitable[yandex.cloud.priv.iam.v1.mfa.hardware.totp_profile_pb2.TotpProfile]]:
        """Retrieves hardware TOTP profile by Id"""

    @abc.abstractmethod
    def List(
        self,
        request: yandex.cloud.priv.iam.v1.mfa.hardware.totp_profile_service_pb2.ListTotpProfilesRequest,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.priv.iam.v1.mfa.hardware.totp_profile_service_pb2.ListTotpProfilesResponse, collections.abc.Awaitable[yandex.cloud.priv.iam.v1.mfa.hardware.totp_profile_service_pb2.ListTotpProfilesResponse]]:
        """Retrieves the list hardware TOTP profiles by organization_id and filter"""

    @abc.abstractmethod
    def Update(
        self,
        request: yandex.cloud.priv.iam.v1.mfa.hardware.totp_profile_service_pb2.UpdateTotpProfileRequest,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.priv.operation.operation_pb2.Operation, collections.abc.Awaitable[yandex.cloud.priv.operation.operation_pb2.Operation]]:
        """Updates hardware TOTP profile"""

    @abc.abstractmethod
    def Delete(
        self,
        request: yandex.cloud.priv.iam.v1.mfa.hardware.totp_profile_service_pb2.DeleteTotpProfileRequest,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.priv.operation.operation_pb2.Operation, collections.abc.Awaitable[yandex.cloud.priv.operation.operation_pb2.Operation]]:
        """Updates hardware TOTP profile by id"""

    @abc.abstractmethod
    def ListOperations(
        self,
        request: yandex.cloud.priv.iam.v1.mfa.hardware.totp_profile_service_pb2.ListTotpProfileOperationsRequest,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.priv.iam.v1.mfa.hardware.totp_profile_service_pb2.ListTotpProfileOperationsResponse, collections.abc.Awaitable[yandex.cloud.priv.iam.v1.mfa.hardware.totp_profile_service_pb2.ListTotpProfileOperationsResponse]]:
        """Retrieves the list of Operations for the specified hardware TOTP profile."""

    @abc.abstractmethod
    def Assign(
        self,
        request: yandex.cloud.priv.iam.v1.mfa.hardware.totp_profile_service_pb2.AssignTotpProfileRequest,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.priv.operation.operation_pb2.Operation, collections.abc.Awaitable[yandex.cloud.priv.operation.operation_pb2.Operation]]:
        """Binds the token to the user for HelpDesk"""

    @abc.abstractmethod
    def Unassign(
        self,
        request: yandex.cloud.priv.iam.v1.mfa.hardware.totp_profile_service_pb2.UnassignTotpProfileRequest,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.priv.operation.operation_pb2.Operation, collections.abc.Awaitable[yandex.cloud.priv.operation.operation_pb2.Operation]]:
        """Unbind the token from the user for HelpDesk"""

    @abc.abstractmethod
    def SyncTimeDrift(
        self,
        request: yandex.cloud.priv.iam.v1.mfa.hardware.totp_profile_service_pb2.SyncTimeDriftRequest,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.priv.operation.operation_pb2.Operation, collections.abc.Awaitable[yandex.cloud.priv.operation.operation_pb2.Operation]]:
        """Synchronizes clocks for hardware tokens. Doesn't activate profile."""

    @abc.abstractmethod
    def Verify(
        self,
        request: yandex.cloud.priv.iam.v1.mfa.hardware.totp_profile_service_pb2.VerifyTotpRequest,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.priv.iam.v1.mfa.hardware.totp_profile_service_pb2.VerifyTotpResponse, collections.abc.Awaitable[yandex.cloud.priv.iam.v1.mfa.hardware.totp_profile_service_pb2.VerifyTotpResponse]]:
        """Verifies user-supplied TOTP value. See https://tools.ietf.org/html/rfc6238#section-5.2 for the reference."""

def add_TotpProfileServiceServicer_to_server(servicer: TotpProfileServiceServicer, server: typing.Union[grpc.Server, grpc.aio.Server]) -> None: ...
